<?php

class ModelExtensionModuleChatbro extends Model
{
    private $events = array(
        'admin/view/common/column_left/before' => array(
            'extension/module/chatbro/view_column_left'
        ),
        'catalog/view/common/header/after' => array(
            'extension/module/chatbro/display_chats',
        ),
        'catalog/view/common/*/before' => array(
            'extension/module/chatbro/init_shortcodes',
        ),
    );

    public function deleteEvents(): void
    {
        $this->load->model('setting/event');
        $this->model_setting_event->deleteEventByCode('chatbro_chats');
    }

    public function createEvents(): void
    {
        $this->load->model('setting/event');

        foreach ($this->events as $trigger => $actions) {
            foreach ($actions as $action) {
                $this->model_setting_event->addEvent('chatbro_chats', $trigger, $action, 1, 0);
            }
        }
    }

    public function createTables(): void
    {
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "chatbro` (
            `id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
            `store_id` INT(11) NOT NULL DEFAULT '0',
            `chatbro_chat_guid` CHAR(36) NOT NULL,
            `chatbro_access_token` VARCHAR(255) DEFAULT NULL,
            `chatbro_refresh_token` VARCHAR(255) DEFAULT NULL,
            `chatbro_chat_secret` VARCHAR(255) NOT NULL,
            `chatbro_chat_list` TEXT DEFAULT NULL,
            `chatbro_enable_shortcodes` TINYINT(1) NOT NULL DEFAULT 1,
            `chatbro_chat_user_profile_url` VARCHAR(255) DEFAULT NULL,
            `chatbro_enabled` TINYINT(1) NOT NULL DEFAULT 1,
            `created_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
            `updated_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
            PRIMARY KEY (`id`),
            UNIQUE KEY `unique_store_id` (`store_id`),
            UNIQUE KEY `unique_chatbro_chat_guid` (`chatbro_chat_guid`)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8");
    }

    public function dropTables(): void
    {
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "chatbro`");
    }
}