<?php

namespace chatbro\chatbroapp\backends;

use \chatbro\chatbroapp\interfaces\IcbroPermissionsBackend;
use \chatbro\chatbroapp\permissions\CbroPermissions;
use \chatbro\chatbroapp\common\CbroCommon;

class CbroPermissionsBackend implements IcbroPermissionsBackend {
  function can($capability, $display_to_guests) {
    
    switch($capability) {
      case CbroPermissions::cap_ban:
        return FALSE;

      case CbroPermissions::cap_delete:
        return FALSE;

      case CbroPermissions::cap_view:
        $logged_in = CbroCommon::is_logged_in();
        
        $can_view = $logged_in ? $this->check_permission(CbroPermissions::cap_view) : FALSE;

        if ((!$display_to_guests && !$logged_in) || ($logged_in && !$can_view))
          return FALSE;

        if (!$display_to_guests && !$logged_in)
          // Don't show the chat to unregistered users
          return FALSE;

        return TRUE;
    }
  }

  function check_permission($permissions) {
    // return current_user_can(CbroPermissions::cap_view);
    return TRUE;
  }

  function can_manage_settings() {
    return FALSE;
  }
}

?>
